
package Library.servlets;

import java.io.IOException;
import java.util.List;

import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;
import org.hibernate.HibernateException;
import org.hibernate.Session;
import org.hibernate.SessionFactory;

import org.hibernate.Transaction;

import Library.servlets.HibernateSessionFactory;



public class BookList extends HttpServlet {

	/**
	 * Constructor of the object.
	 */
	public BookList() {
		super();
	}

	/**
	 * Destruction of the servlet
	 */

	public void destroy() {
		super.destroy(); // Just puts "destroy" string in log
		// Put your code here
	}

	// The doPost method of the servlet 

	public void doPost(HttpServletRequest request, HttpServletResponse response)
			throws ServletException, IOException {
       
		InitialContext ctx=null;
		
		
		
		try {
			ctx = new InitialContext();
		} catch (NamingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		Session session = null;
		Transaction tx = null;
		
		Logger log = Logger.getLogger("BookList");
		
		try {
			
			
			// get the session from the factory
			session = HibernateSessionFactory.currentSession();

			// always start a transaction before doing something
			// (even reading) from the database
			tx = session.beginTransaction();
						
		
		
		    List Books = session.createQuery("from Book").list();//returns all the instances ie db rows
			
			request.setAttribute("books",Books);
			
			RequestDispatcher dispatcher = getServletContext().getRequestDispatcher("/jsp/bookList.jsp");
						
			//forward to the jsp file to display the book list
			dispatcher.forward(request, response);	
									
			
			// clean up (close the session)
			tx.commit();
			session.close();

		} catch (HibernateException e) {

			//  when an error occured, try to rollback your
			// transaction
			if (tx != null)
				try {
					tx.rollback();
				} catch (HibernateException e1) {
					log.warn("rollback not successful");
				}
			
			if (session != null)
				try {
					session.close();
				} catch (HibernateException e2) {
					log.warn("session close not successful");
				}
		}


					
	}



// The doGet method of the servlet 
	
	public void doGet(HttpServletRequest request, HttpServletResponse response)
			throws ServletException, IOException {
		
		RequestDispatcher dispatcher = getServletContext().getRequestDispatcher("/jsp/bookEdit.jsp");
		dispatcher.forward(request, response);	
			}

	
	public void init() throws ServletException {
		// Put your code here
	}

}
